/*************************************/
/*****        DRAWPROG.C         *****/
/***** * MSX Machine Specific *  *****/
/***** Written using HiSoft C++  *****/
/***** (c) John Finlayson 9.7.86 *****/
/***** Runtimes Copyright HiSoft *****/
/*************************************/

/*****   Requires SCR2DUMP.BIN  *****/

#data 0xa000      /* (scr2dump currently loaded at 0xb000) */
#include basic.h
#include stdio.h

FAST int statflag=-1,csrclr=1,drawclr=1,runflag=1,
         dx=100,dy=100,pendown=-1,tool=1,
         forclr=1,bakclr=15,bdrclr=14,menuclr=14;

main()
{
 FILE *fp,*fopen();
 FAST char *chk_heap;
 if(!(chk_heap=calloc(0x1800,2)))/* check space */
 {
  printf("\nInsufficient buffer space");
  printf("\n- set HEAPSIZE to 0x3100 in stdio.lib");
  exit(0);
 }
 free(chk_heap);
 /* load screen dump at 0xb000 */
 if(!(fp=fopen("SCR2DUMP.BIN","rb")))
 {
  printf("\nCannot open file `SDUMP.BIN'");
  exit(0);
 }
 set_call();
 read(fp,0xb000,0xda);
 fclose(fp);

 setup();
 mainloop();
   /* exit */
 fill_wind(72,80,215,100);
 gprint40(80,88,"One moment please...");
 run_com("START");
}

setup()
{
 screen(2);  colour(forclr,bakclr,bdrclr);
 clear_s();  spr_size(0);
 def_sprite(0,"0030df8cd830");    /* menu cursor */
 def_sprite(1,"e090884422110a04");/* pen 1       */
 def_sprite(2,"f8f8f800f8702020");/* brush 	 */
 def_sprite(3,"ff82848890a0c080");/* line        */
 def_sprite(4,"ffc1a191898583ff");/* box 	 */
 def_sprite(5,"ff81bdbdbdbd81ff");/* block 	 */
 def_sprite(6,"80785e6661303008");/* circle 	 */
 def_sprite(7,"ffa0e180828088a0");/* arc	 */
 def_sprite(8,"e03e22728a8888f8");/* aerosol 	 */
 def_sprite(9,"e0c6a70d7bfffe7c");/* paint 	 */
 def_sprite(10,"ff80808689888986");/* copycursor */
 def_sprite(11,"ffab81d581ab81ff");/* pat symbol */
 def_sprite(12,"aaaaaaaaaaaaaaaa");/* patterns */
 def_sprite(13,"ff00ff00ff00ff00");
 def_sprite(14,"9249249249249249");
 def_sprite(15,"4992244992244992");
 def_sprite(16,"aa55aa55aa55aa55");
 def_sprite(17,"aaffaaffaaffaaff");
 def_sprite(18,"8822882288228822");
 def_sprite(19,"08086caaaa6c");    /* letter */
 def_sprite(39,"01010101010101ff");/* letter */
 def_sprite(20,"c3810000000081c3");/* mag */
 def_sprite(21,"101010fe10101010");/* 2nd cursor */
 
 def_sprite(22,"9565659301050200");/* status */
 def_sprite(23,"02043c3c42427e3c");/* colour */
 def_sprite(24,"e0e002e54a5418");  /* tool   */
 def_sprite(25,"ffefefefe3ffffe7");/* load   */
 def_sprite(26,"dba19985b98199e7");/* save   */
 def_sprite(27,"003e224444febefe");/* dump   */
 def_sprite(28,"f09894f24121110f");/* clear  */
 def_sprite(29,"ffc7bbbbabc7fbff");/* exit   */

}

mainloop()
{
 while(TRUE)
 {
  mainmenu();
  if(!runflag) break;
  draw(tool);
 }
}

mainmenu()
{
 FAST char *menu1_st;
 FAST int mainchoice,i,yn;
 menu1_st=set_wind(16,10,95,102);
 fill_wind(16,10,95,102);
 put_sprite(1,32,10,1,tool);
 put_sprite(22,32,20,1,22);
 put_sprite(23,32,30,4,23);
 put_sprite(24,32,40,1,24);
 put_sprite(25,32,50,1,25);
 put_sprite(26,32,60,6,26);
 put_sprite(27,32,70,1,27);
 put_sprite(28,32,80,1,28);
 put_sprite(29,32,90,6,29);
 gprint40(55,24,"Ink");
 gprint40(44,44,"Text");
 gprint40(47,54,"Fore");
 gprint40(47,64,"Back");
 upd_clr();
 colour(forclr,bakclr,bdrclr);
 while(TRUE)
 {
  mainchoice=choose(22,10,10,90);
  if(mainchoice==10) break;
  switch(mainchoice)
  {
   case 20: stat_tog(); break;
   case 30: colourm(0); break;
   case 40: toolm(); break;
  }
  put_sprite(1,32,10,1,tool);
  upd_clr();
  if(mainchoice>40) break;
  delay(1000);
 }
 if(mainchoice==10 && tool==19)
 {
  yn=prtm(1);
  if(yn)  change_clr(0);
 }
 un_sprite(0);  un_sprite(1);
 for(i=22;i<30;i++)  un_sprite(i);
 end_wind(16,10,95,100,menu1_st);
 if(mainchoice==10)  {  delay(1000);  return;  }
 if(statflag>0)  stat_tog();
 if(yn=prtm(0))
 {
  switch(mainchoice)
  {
   case 50: ld_dir(); break;
   case 60: diskpic(); break;
   case 70: calslt(0,0,0,0,0xb000); break;
   case 80: change_clr(1); clear_s(); break;
   case 90: runflag=0; return;
  }
 }
 delay(1000);
}

/* get response */

prtm(cond)
{
 FAST char *prtcl;
 FAST int ans;
 prtcl=set_wind(72,80,224,112);
 fill_wind(72,80,231,112);
 if(cond)  gprint40(80,88,"Change colours?");
 else      gprint40(80,88,"Are you sure?");
 gprint40(198,88,"N");  gprint40(198,96,"Y");
 colour(forclr,bakclr,bdrclr);
 delay(500);
 ans=choose(188,88,88,96);
 end_wind(72,80,224,112,prtcl);
 return (ans-88);
}

/* update main menu colour info */

upd_clr()
{
 block(80,24,87,31,drawclr);
 block(80,54,87,61,forclr);
 block(80,64,87,71,bakclr);
}

/* status display on/off */

stat_tog()
{
 FAST char *stat_st;
 statflag=-statflag;
 if (statflag>0)
 {
  stat_st=set_wind(0,180,79,191);
  block(0,180,79,191,menuclr);
  pxy();
 }
 else  end_wind(0,180,79,191,stat_st);
}

/* save screen - disc */

diskpic()
{
 FAST char flet,filename[15],*dmenu_st;
 FAST int i,fileok,gt,ox,oy,d;
 ox=dx; oy=dy; dx=30; dy=39;
 dmenu_st=set_wind(16,29,97,49);
 fill_wind(16,29,103,52);
 if(dskf(0) < 12)
 {
  gprint40(30,30,"Not enough");  gprint40(30,38,"disk space");
  delay(20000);
  end_wind(16,29,97,49,dmenu_st);
  dx=ox; dy=oy;
  colour(forclr,bakclr,bdrclr);
  return;
 }
 gprint40(30,30,"Filename:");
 for(i=0;i<15;i++)  filename[i]=0;
 while(TRUE)
 {
  flet=0; gt=0;
  while(!isalnum(flet))  flet=put_let(menuclr);
  filename[(dx/6)-5]=flet;
  while((d=stick(1))!=3 && d!=7)
  {
   if(strig(3))  {  gt=1;  break;  }
  }
  if(gt)break;
  if (d==3 && dx<72) dx+=6;
  if (d==7 && dx>30) dx-=6;
 }
 strcat(filename,".GRP");
 end_wind(16,29,97,49,dmenu_st);
 dx=ox; dy=oy;
 colour(forclr,bakclr,bdrclr);
 if(fileok=save_gscr(filename,0,0x17ff))  return;
 file_err();
}

/* load screen - disc */

ld_dir()
{
 FAST char *dir_str,picname[15];
 FAST int yn;

 dir_str=calloc(1000,1);
 get_dir(0,0,"*.grp",dir_str);
 if(!*dir_str) return;
 yn=use_dir(dir_str,picname);
 free(dir_str);

 if(!yn) return;
 if(yn=load_gscr(picname))  return;
 file_err();
}

use_dir(str,item)
char *str,*item;
{
 FAST char *s,*dirstore;
 FAST int j,g;
 dirstore=set_wind(16,10,107,43);
 fill_wind(16,10,111,43);
 gprint40(36,30,"More>>");  gprint40(36,10,"Abort");
 while(TRUE)
 {
  s=str;
  while(*s)
  {
   blt(item,s,8);
   for(j=0;j<9;j++)
   {
    if(!isalnum(item[j]))  {  item[j]=0;  break;  }
   }
   item[8]=0;  gprint40(32,20,item);
   delay(500);
   g=choose(20,20,10,30);
   if(g==20)
    {
     colour(forclr,bakclr,bdrclr);
     end_wind(16,10,107,43,dirstore);
     strcat(item,".GRP");
     return 1;
    }
   if(g==10)
   {
    colour(forclr,bakclr,bdrclr);
    end_wind(16,10,107,43,dirstore);
    return NULL;
   }
   block(20,20,107,29,menuclr);
   s+=8;
  }
 }/* end while TRUE */
}

get_dir(drive, user, afn, sp)
  int drive, user;
  char *afn, *sp;
{
  FAST char cont_;
  FAST int search_code;
  char filename[13],fcb[36],disk_buffer[128];
  cpm_bdos(26, disk_buffer); /* set dma  */
  cpm_pfcb(fcb, afn);        /* make fcb */
  if(fcb[0])  drive=fcb[0]-1;
  search_code=17;	/* search for first */
  while((cont_=cpm_bdos(search_code,fcb)) != 255)
  {
   search_code = 18;	/* search for next */
   store_name(filename,disk_buffer+cont_*32);
   sprintf(sp,"%-8s",filename);
   sp+=8;
  }
}


void store_name(filename,fcb)
char *filename, *fcb;
{
 blt(filename, fcb+1, 8);
 filename[8]  = 0;
}

/* main draw routine */

draw(tool)
{
 switch(tool)
 {
  case 1: case 2: pencil(); break;
  case 3: case 4: case 5: case 6:
  case 7:         linear(); break;
  case 10: trans(); break;
  
  case 8:  case 9:  case 11:
  case 12: case 13: case 14:
  case 15: case 16: case 17:
  case 18: case 19: pat_n_paint(); break;
  
  case 20: magnify(); break;
 }
}

pencil()
{
 delay(500);
 while(!strig(3))
 {
  put_sprite(0,dx,dy,csrclr,tool);
  if(strig(1))
  {
   beep();  pendown=-pendown;
   if(statflag>0) pxy();
   delay(1000);
  }
  if(pendown>0)
  {
   if(tool<2)  pset(dx,dy,drawclr);
   else        line(dx,dy,dx+4,dy,drawclr);
  }
  move_xy(0);
  delay(500);
  if(statflag<0)  delay(500);
 }
 if(pendown>0)
 {
  pendown=-1;
  if(statflag>0)  pxy();
 }
}

pat_n_paint()
{
 FAST int i,px,py;
 FAST char mask,tool_byte[8],r0,r1,r2;
 delay(500);
 while(TRUE)
 {
  if(tool==19) tool=39;
  while(TRUE)
  {
   if(strig(3))
   {  if(tool==39) tool=19;  return;  }
   if(strig(1)) break;
   put_sprite(0,dx,dy-1,csrclr,tool);
   move_xy(0);
   if(statflag<0) delay(500);
  }
  beep();
  if(tool==9)
  {  paint(dx,dy,drawclr);  delay(1000);  }
  if(tool>11 && tool<19)
  {
   reg_hl=calslt(tool,0,0,0,0x6e4);
   vram_ram(reg_hl,tool_byte,8);
   for(py=0;py<8;py++)
   {
    mask=128;
    for(px=dx;px<dx+8;px++)
    {
     if(mask & tool_byte[py])  pset(px,dy+py,drawclr);
     mask>>=1;
    }
   }
  }
  if (tool==39)  put_let(bakclr);
  if (tool==8)
  {
   r0=rand();
   while(r0>8)  r0>>=1;
   for(i=0;i<r0+2;i++)
   {
    r1=rand(); r2=rand();
    while(r1>9)  r1>>=1;
    while(r2>9)  r2>>=1;
    pset(2+dx-r1,2+dy-r2,drawclr);
   }
  }
 }
}

/* line,box,block */

linear()
{
 FAST int rad,hrad,asp,lx,ly,st,en;
 delay(500);
 while(!strig(3))
 {
  delay(500);
  put_sprite(0,dx,dy-1,csrclr,tool);
  move_xy(0);
  if(strig(1))
  {
   lx=dx; ly=dy;
   if(tool>5)  un_sprite(0);
   put_sprite(29,dx-3,dy-4,csrclr,21);
   beep();  delay(1000);
   while(!strig(1))
   {
    delay(500);
    if(tool<6)  put_sprite(0,dx,dy-1,csrclr,tool);
    if(tool>3)
    {
     put_sprite(30,lx-3,dy-4,csrclr,21);
     put_sprite(31,dx-3,ly-4,csrclr,21);
    }
    move_xy(0);
   }
   beep();
   if(tool==3)  line(lx,ly,dx,dy,drawclr);
   if(tool==4)  box(lx,ly,dx,dy,drawclr);
   if(tool==5)  block(lx,ly,dx,dy,drawclr);
   if(tool>5)
   {
    rad=abs(dx-lx);
    hrad=abs(dy-ly);
    if(!hrad)     hrad=1;
    asp=(100*(hrad))/rad;
    if(rad<hrad)  rad=hrad;
    if(asp<=0)    asp=1;
    if(tool==7)
    {
     if(dx>lx&&dy<ly)  st=0;
     if(dx>lx&&dy>ly)  st=270;
     if(dx<lx&&dy<ly)  st=90;
     if(dx<lx&&dy>ly)  st=180;
     en=st+90;
     if(dx==lx||dy==ly)  en=st=0;
    }
    else  {  st=0; en=360;  }
    circle(lx,ly,rad,drawclr,st,en,asp);
    dx=lx; dy=ly;
   }
   un_sprite(29);  un_sprite(30);  un_sprite(31);
   delay(500);
  }
 }
}

magnify()
{
 FAST char mask,cl,fc,bc,byte[8],cbyte[8],*mag_st;
 FAST int sf,vsource,ix,iy,ox,oy,spcl;
 dx&=0xf8; dy&=0xf8;
 put_sprite(0,dx,dy-1,csrclr,tool);
 while(!strig(3))
 {
  move_xy(1);
  put_sprite(0,dx,dy-1,csrclr,tool);
  delay(1000);
  if(strig(1))
  {
   beep(); ox=dx; oy=dy;
   vsource=((dy/8)*256)+dx;
   vram_ram(vsource,byte,8);
   vram_ram(vsource+0x2000,cbyte,8);
   mag_st=set_wind(80,80,136,136);
   block(80,80,142,142,menuclr);
   for(iy=0;iy<8;iy++)
   {
    bc=cbyte[iy]&0xf;  fc=cbyte[iy]>>4;
    if(fc==0)
    {
     fc=bakclr;
     if(fc==bc)  fc=drawclr;
     cbyte[iy]|=fc<<4;
    }
    mask=128;
    for(ix=0;ix<8;ix++)
    {
     dx=(ix*8)+80; dy=(iy*8)+80;
     cl=(byte[iy]&mask)?fc:bc;
     block(dx,dy,dx+6,dy+6,cl);
     mask>>=1;
    }
   }
   put_sprite(0,dx,dy-1,csrclr,tool);
   sf=0;
   if(statflag>0)  {  sf=1;  statflag=-1;  }
   while(!strig(3))
   {
    move_xy(1);
    if(dx>136) dx=136;
    if(dx<80)  dx=80;
    if(dy>136) dy=136;
    if(dy<80)  dy=80;
    spcl=(get_colour(dx,dy)==1) ? 15 : 1;
    put_sprite(0,dx,dy-1,spcl,tool);
    delay(1000);
    if(strig(1))
    {
     beep();
     iy=(dy/8)-10;  ix=(dx/8)-10;
     mask=128;      mask>>=ix;
     bc=cbyte[iy]&0xf;  fc=cbyte[iy]>>4;
     if(mask&byte[iy])
     {  cl=bc;  byte[iy]&=~mask;  }
     else
     {  cl=fc;  byte[iy]|=mask;  }
     block(dx,dy,dx+6,dy+6,cl);
     delay(1000);
    }
   }
   end_wind(80,80,136,136,mag_st);
   ram_vram(byte,vsource,8);
   ram_vram(cbyte,vsource+0x2000,8);
   dx=ox; dy=oy;
   if(sf) statflag=1;
   delay(2000);
  }
 }
}

trans() /* copy, rotate, invert */
{
 FAST char *tbuff,*tb;
 FAST int rot_inv,wt,ht,sx,sy,tx,ty,i,j;
 if(!(tbuff=set_wind(80,72,157,135))) return;
 fill_wind(80,72,157,135);
 gprint40(93,80,"Fast copy");
 gprint40(93,90,"Slow copy");
 gprint40(93,100,"Rotate 90");
 gprint40(93,110,"Invert ^v");
 gprint40(93,120,"Invert <>");
 rot_inv=choose(84,80,80,120);
 end_wind(80,72,157,135,tbuff);
 if(rot_inv==80)
 { move_block(); return; } /* fast copy */
 put_sprite(0,dx,dy-1,csrclr,tool);
 while(!strig(3))
 {
  move_xy(0);
  put_sprite(0,dx,dy-1,csrclr,tool);
  delay(800);
  if(strig(1))
  {
   tx=dx; ty=dy;
   put_sprite(29,tx-3,ty-4,csrclr,21);
   beep();
   while(TRUE)
   {
    delay(800);
    move_xy(0);
    if(dx<tx) dx=tx;
    if(dy<ty) dy=ty;
    put_sprite(0,dx-3,dy-4,csrclr,21);
    put_sprite(30,dx-3,ty-4,csrclr,21);
    put_sprite(31,tx-3,dy-4,csrclr,21);
    if (strig(1)) break;
   }
   beep();
   put_sprite(29,tx,ty,csrclr,tool);
   put_sprite(0,dx,dy,csrclr,tool);
   put_sprite(30,dx,ty,csrclr,tool);
   put_sprite(31,tx,dy,csrclr,tool);
   ht=dy-ty; wt=dx-tx;
   if(!(tbuff=calloc((ht+1)*(wt+1),1))) /* memory intensive */
   {
    un_sprite(0); un_sprite(29); un_sprite(30); un_sprite(31);
    tbuff=set_wind(72,80,199,100);  fill_wind(72,80,199,100);
    gprint40(80,86,"Insufficient memory");
    delay(20000);  end_wind(72,80,199,100,tbuff);
    return;
   }
   tb=tbuff;
   for(i=ty;i<dy+1;i++)
   {
    for(j=tx;j<dx+1;j++)
    {
     *tb=get_colour(j,i);  tb++;
    }
   }
   dx=tx; dy=ty; /* top left */
   if(rot_inv==100) /* rotate */
   {
    while(TRUE)
    {
     delay(800);
     move_xy(0);
     if((dx+ht)>255) dx=255-ht;
     if((dy+wt)>191) dy=191-wt;
     put_sprite(0, dx-3,   dy-4,   csrclr,21);
     put_sprite(29,dx-3,   dy+wt-4,csrclr,21);
     put_sprite(30,dx+ht-3,dy-4,   csrclr,21);
     put_sprite(31,dx+ht-3,dy+wt-4,csrclr,21);
     if(strig(1)) break;
    }
    beep();
    tb=tbuff;  sx=dx+ht+1;
    for(i=ht+1;i>0;i--)
    {
     sx--; sy=dy-1;
     for(j=wt+1;j>0;j--)
     {
      sy++;
      pset(sx,sy,*tb);  tb++;
     }
    }
   }
   else
   {
    while(TRUE)
    {
     delay(800);
     move_xy(0);
     if((dx+wt)>255) dx=255-wt;
     if((dy+ht)>191) dy=191-ht;
     put_sprite(0, dx-3,   dy-4,   csrclr,21);
     put_sprite(29,dx-3,   dy+ht-4,csrclr,21);
     put_sprite(30,dx+wt-3,dy-4,   csrclr,21);
     put_sprite(31,dx+wt-3,dy+ht-4,csrclr,21);
     if(strig(1)) break;
    }
    tb=tbuff;
    if(rot_inv==90) /* slow copy */
    {
     for(i=dy;i<dy+ht+1;i++)
     {
      for(j=dx;j<dx+wt+1;j++)
      {  pset(j,i,*tb++);  }
     }
    }
    if(rot_inv==110) /* invert ^v */
    {
     for(i=dy+ht;i>dy-1;i--)
     {
      for(j=dx;j<dx+wt+1;j++)
      {  pset(j,i,*tb++);  }
     }
    }
    if(rot_inv==120) /* invert <> */
    {
     for(i=dy;i<dy+ht+1;i++)
     {
      for(j=dx+wt;j>dx-1;j--)
      {  pset(j,i,*tb++);  }
     }
    }
   } /* end else */
   free(tbuff);
   un_sprite(29);  un_sprite(30);  un_sprite(31);
   delay(1000);
  }
 } /* while !strig 3 */
}

move_block() /* fast copy */
{
 FAST char *tbuff;
 FAST int wt,ht,tx,ty;
 dx&=0xf8; dy&=0xf8; /* will only copy 8x8 blocks */
 put_sprite(0,dx,dy-1,csrclr,tool);
 while(!strig(3))
 {
  move_xy(1);
  put_sprite(0,dx,dy-1,csrclr,tool);
  delay(1000);
  if(strig(1))
  {
   tx=dx; ty=dy;
   put_sprite(29,tx-3,ty-4,csrclr,21);
   beep();
   while(TRUE)
   {
    delay(1000);
    move_xy(1);
    if(dx<tx) dx=tx;
    if(dy<ty) dy=ty;
    put_sprite(0,dx+4,dy+3,csrclr,21);
    put_sprite(30,dx+4,ty-4,csrclr,21);
    put_sprite(31,tx-3,dy+3,csrclr,21);
    if (strig(1)) break;
   }
   beep();
   put_sprite(29,tx,ty,csrclr,tool);
   put_sprite(0,dx+4,dy+3,csrclr,tool);
   put_sprite(30,dx+4,ty-4,csrclr,tool);
   put_sprite(31,tx-3,dy+3,csrclr,tool);
   tbuff=set_wind(tx,ty,dx,dy);
   ht=dy-ty; wt=dx-tx;
   while(TRUE)
   {
    delay(1000);
    move_xy(1);
    if(dx-wt<0) dx+=8;
    if(dy-ht<0) dy+=8;
    put_sprite(0,dx+4,dy+3,csrclr,21);
    put_sprite(29,dx-wt-3,dy-ht-4,csrclr,21);
    put_sprite(30,dx-wt-3,dy+3,csrclr,21);
    put_sprite(31,dx+4,dy-ht-4,csrclr,21);
    if(strig(1)) break;
   }
   beep();
   end_wind(dx-wt,dy-ht,dx,dy,tbuff);
   un_sprite(29);  un_sprite(30);  un_sprite(31);
   delay(1000);
  }
 }
}

/* graphic cursor routine */

move_xy(op)
{
 FAST int d;
 op*=7; op++;
 d=stick(1);
 switch(d)
 {
  case 1: dy-=op; break;
  case 5: dy+=op; break;
  case 3: dx+=op; break;
  case 7: dx-=op; break;
  case 2: dy-=op; dx+=op; break;
  case 4: dy+=op; dx+=op; break;
  case 6: dy+=op; dx-=op; break;
  case 8: dy-=op; dx-=op; break;
 }
 if(dx<0)  dx=0;
 if(dy<0)  dy=0;
 if(op<2)
 {
  if(dx>255)  dx=255;
  if(dy>191)  dy=191;
 }
 else
 {
  if(dx>248)  dx=248;
  if(dy>184)  dy=184;
 }
 if(d && statflag>0)  pxy();
}

/* tool menu */

toolm()
{
 FAST char *tmenu_st;
 FAST int tool_y;
 tool_y=20;
 tmenu_st=set_wind(88,19,111,143);
 fill_wind(88,19,111,143);
 colour(forclr,bakclr,bdrclr);
 for(tool=1;tool<12;tool++)
 {
  put_sprite(tool,101,tool_y,1,tool);
  tool_y+=10;
 }
 put_sprite(20,101,tool_y,1,20);
 tool=choose(92,20,20,130);
 tool=(tool-10)/10;
 if(tool==12) tool=20;
 if(tool==11)  patm();
 un_sprite(20);
 for(tool_y=11;tool_y>0;tool_y--)
  un_sprite(tool_y);
 end_wind(88,19,111,143,tmenu_st);
}

/* change vdp colours */

change_clr(chcl)
{
 FAST int savclr;
 savclr=drawclr;
 while(TRUE)
 {
  delay(200);
  colourm(1); forclr=drawclr;
  delay(200);
  colourm(2); bakclr=drawclr;
  if(forclr!=bakclr) break;
 }
 if(chcl)
 {
  delay(200);
  colourm(3);  bdrclr=drawclr;
 }
 menuclr= bakclr==15 ? 14 : 15;
 drawclr=savclr;
 colour(forclr,bakclr,bdrclr);
}

/* colour menu */

colourm(chse)
{
 FAST char *cmenu_st;
 FAST int btm,col,col_y;
 btm=160;
 if(!chse) btm=170;
 col_y=20;
 cmenu_st=set_wind(88,19,119,180);
 fill_wind(88,19,119,180);
 for(col=1;col<16;col++)
 {
  block(104,col_y,111,col_y+8,col);
  switch(col)
  {
   case 1: case 2: case 4: case 6: case 8: case 12: case 13:
   block(114,col_y+6,116,col_y+8,1);  break;
  }
  col_y+=10;
 }
 box(103,col_y-20,112,col_y-12,1);
 box(103,col_y-10,112,col_y-2,1);
 switch(chse)
 {
  case 0: put_sprite(2,104,169,1,1); break;
  case 1: gprint40(104,170,"F"); break;
  case 2: gprint40(104,170,"B"); break;
  case 3: gprint40(104,170,"b"); break;
 }
 col=choose(91,20,20,btm);
 if (col==170)  csrclr=(csrclr==1) ? 15 : 1;
 else           drawclr=(col-10)/10;
 if(!chse) un_sprite(2);
 colour(forclr,bakclr,bdrclr);
 end_wind(88,19,119,180,cmenu_st);
}

/* pattern menu */

patm()
{
 FAST char *pmenu_st;
 FAST int pat_y;
 pat_y=30;
 pmenu_st=set_wind(108,29,131,110);
 fill_wind(108,29,135,110);
 colour(forclr,bakclr,bdrclr);
 for(tool=12;tool<20;tool++)
 {
  put_sprite(tool,121,pat_y,1,tool);
  pat_y+=10;
 }
 tool=choose(112,30,30,100);
 tool=(tool/10)+9;
 for(pat_y=19;pat_y>11;pat_y--)
  put_sprite(pat_y,1,210,1,pat_y);
 end_wind(108,29,131,110,pmenu_st);
}

/* print letter to screen */

put_let(paper)
{
 FAST char letter;
 FAST int d;
 letter=65;
 delay(1000);
 while(!strig(1))
 {
  d=stick(1);
  switch(d)
     {
      case 1: letter--; break;
      case 3: letter=65; break;
      case 5: letter++; break;
      case 7: letter=97; break;
     }
  if(letter<32)  letter=254;
  if(letter>254) letter=32;
  block(dx+7,dy+7,dx,dy,paper);
  calslt(letter,0,0,0,0x8d);
  if(strig(1))   break;
  delay(1000);
 }
 beep();  delay(1000);  return letter;
}

/* item selection for menus */

choose(csr_x,csr_y,min_y,max_y)
{
 FAST int d;
 put_sprite(0,csr_x,csr_y,1,0);
 while(!strig(1))
 {
   delay(1000);
   if(strig(1))  break;
   d=stick(1);
   if(d==1 && csr_y>min_y)  csr_y-=10;
   if(d==5 && csr_y<max_y)  csr_y+=10;
   put_sprite(0,csr_x,csr_y,1,0);
 }
 beep();  un_sprite(0);  return csr_y;
}

/* status display */

pxy()
{
 FAST int cl;
 FAST char xstr[8];
 sprintf(xstr,"%d %d",dx,dy);
 block(8,180,71,191,menuclr);
 cl=(dx%8==0&&dy%8==0) ? 4 : dx%8==0 ? 12 : 1;
 colour(cl,menuclr,bdrclr);
 gprint40(8,182,xstr);
 block(64,183,71,185,drawclr);
 if(pendown>0)  block(64,186,71,188,drawclr);
 box(63,182,72,189,1);
 colour(forclr,bakclr,bdrclr);
}

/* general disc error */

file_err()
{
 FAST char *dm_st;
 dm_st=set_wind(16,29,95,49);
 fill_wind(16,29,95,49);
 gprint40(30,30,"FILE");  gprint40(30,40,"ERROR");
 delay(20000);
 end_wind(16,29,95,49,dm_st);
 colour(forclr,bakclr,bdrclr);
}

/* colour window area */

fill_wind(x1,y1,x2,y2)
{
 block(x1+2,y1,x2,y2-3,menuclr);
 block(x1,y1+2,x1+1,y2,1);
 block(x1,y2-2,x2-2,y2,1);
 colour(1,menuclr,bdrclr);
}

/* delay routine */

delay(duration)
{
 while(duration-- > 0);
}
#include ?basic.lib?
#include ?cpm.lib?
#include ?stdio.lib?
/*************************************/
/*****     End of DRAWPROG.C     *****/
/*************************************/
b?
/*************************************/
/*****     End of DRAWPROG.C     *****/
/***********