/**************************************/
/*****         START.C            *****/
/***** (c) John Finlayson  8.7.86 *****/
/*****   Written for HiSoft C++   *****/
/***** Runtimes Copyright HiSoft  *****/
/***** MSX Disk Utility Programme *****/
/***** (customize to suit needs)  *****/
/**************************************/
#include basic.h
#include stdio.h

#define WIDTH  8       /* screen display for HEX dump */
#define KEYBUF 0xfbf0
#define PUTPNT 0xf3f8
#define GRPPRT 0x8d

FAST char prt_[20], *trig_name, fcb1[52], run_name[]="COMMAND ";
FAST int drive_tog, stk_id, left_marg;

main()
{
 FAST char *chk_heap, to_day[15];
 FAST int stk_csr;
 set_call(); /* install code for ROM calls */
 if(!(chk_heap=calloc(0x1800,2))) /* check/assemble heap */
 {
  screen(0);  printf("\nNot enough heap");
  run_com(run_name);  exit(0);
 }
 free(chk_heap);
 prt_data(); /* initialize printer drive */
 colour(1,14,14);  screen(2);  spr_size(0);
 def_sprite(0,"0030df8cd830");    /* hand cursor */
 def_sprite(1,"00000000000081ff");/* underline   */
 colour(1,15,14);
 block(0,0,255,10,7);     line(0,11,255,11,1);
 block(0,180,255,190,7);  line(0,191,255,191,1);
 gprint40(20,2,"run  fil  prt  drv  BAS");
 old_date(); /* uses struct date declared in BASIC.H */
 sprintf(to_day,"%s %02d:%02d:%d",date.day_name,date.day,date.month,date.year);
 gprint40(170,2,to_day);

 drive_tog=cpm_drive(-1);
 delete("st1x.bat"); /* this is used in copy routine */

 gprint40(20,182,"Choose joystick or cursor keys");
 while(!(stk_csr=stick(0)) && !stick(1));
 stk_id=stk_csr ? 0 : 1;   trig_name=stk_id ? "FIRE" : "SPACE";
 mainloop();
}

mainloop()
{
 FAST int choice;
 while(TRUE)
 {
  block(0,180,200,190,7);
  gprint40(20,182,"< > then");  gprint40(74,182,trig_name);
  info();

  choice=choose(10,2,10,160,30,1);
  switch(choice)
  {
   case 10: use_dir(1); break;    /* run */
   case 40: use_dir(0); break;    /* fil */
   case 70:  printer(); break;    /* prt */
   case 100: change_drv(); break; /* drv */
   case 130: basic(); break;      /* BAS */
   case 160: alter_date(); break;
  }
 }/* end while TRUE */
}

basic() /* in page 1, slot 3 */
{  screen(0);  inline(CALL, 0xf368, 0xC3, 0x4022);  }

change_drv()
{
 drive_tog=drive_tog ? 0 : 1;
 set_x_y(0,100);          /* coords for any system messages */
 cpm_drive(drive_tog);  dskf(0);
 block(0,100,250,123,14); /* clear any system messages */
}

use_dir(run)
{
 FAST char fname[20][13],*str,dir_str[113*12];
 FAST int x,y,pos,action,loopflag;
 while(TRUE) /* 1 */
 {
  loopflag=0;
  block(20,180,200,190,7);
  info();
  if(run) get_dir("*.com",dir_str);
  else    get_dir("*.*",dir_str);
  gprint40(20,182,"^ v then");  gprint40(74,182,trig_name);

  while(TRUE) /* 2 */
  {
   x=170; y=16; str=dir_str;
   fill_wind(157,14,247,122);
   while(*str)
   {
    pos=(y/8)-2;  blt(fname[pos],str,8);
    fname[pos][8]=run ? 0 : '.';
    str+=8;  blt(fname[pos]+9,str,4);
    str+=4;  gprint40(x,y,fname[pos]);
    y+=8;
    if(y>88 || *str==NULL)
    {
     if(*str)  gprint40(x,y," More>>");
     else      gprint40(x,y," Begin>");
     gprint40(x,y+8," Quit");
     for(;;)
     {
      action=choose(161,y,16,y+8,8,0);
      if(action>=y) break;
      {
       if(react(fname[(action/8)-2],run))
        loopflag=1;
       block(13,18,97,82,14);
      }
      if(loopflag) break;
     }
     if(action>y)              /* quit */
     {  block(157,14,247,122,14);  return;  }

     y=16; fill_wind(157,14,247,122); /* continue */
    }
   if(loopflag) break;
   }  /* end while *str */
  if(loopflag) break;
  }   /* end while TRUE 2 */
 }    /* end while TRUE 1 */
}

react(filename,run) /* do something with chosen file */
char *filename;
{
 FAST int action;
 FAST unsigned size;
 FAST char fname[13],size_str[12],purpose[7];
 fill_wind(13,18,97,82);
 blt(fname,filename,13); /* protect filename in case of return */
 if(run)                      /* exit */
 {
  if(sure(fname,"run")==NULL)  return 0;
  kilbuf();     /* get rid of keyhits */
  if(strncmp("ED80",fname,4))  blt(run_name,fname,8); /* diff */
  else  ed80_exit();
  screen(0);  printf("One moment please...");
  run_com(run_name);  exit(0);
 }

 gprint40(24,20,fname);
 cpm_pfcb(fcb1,fname);
 cpm_bdos(15,fcb1);
 size=cast(unsigned)fcb1[16];
 cpm_bdos(14,fcb1);
 sprintf(size_str,"%d bytes",size);
 gprint40(24,28,size_str);  gprint40(26,38,"Copy");
 gprint40(26,46,"Rename");
 colour(8,15,14);  gprint40(26,54,"Kill"); colour(1,15,14);
 gprint40(26,62,"View");    gprint40(30,70,"Quit");
 action=choose(17,38,38,70,8,0);
 if(action==70) return NULL;
 switch(action)
 {
   case 54: blt(purpose,"Kill",5);   break;
   case 46: blt(purpose,"Rename",7); break;
   case 38: blt(purpose,"Copy",5);   break;
   case 62: blt(purpose,"View",5);   break;
   default: return NULL;
 }
 if(sure(fname,purpose)==NULL) return NULL;
 switch(action)
 {
   case 54: return (kill(fname));
   case 46: return (rename(fname));
   case 38: copy (fname);      return TRUE;
   case 62: typefile (fname);  return NULL;
   default: return NULL;
 }
}

/* To avoid constant disk changing for single drives    */
/* - due to lack of memory -  this routine runs through */
/* command.com. A more elegant function could easily    */
/* replace it if there is more than one drive.          */

copy(oldname)
char *oldname;
{
 FAST char *store2,sour_dr,dest_dr,newn[13],newname[15];
 FAST int ch,cerr;
 FILE *fp,*fopen();
 setname(oldname,newn,0);
 chk_name(oldname);       chk_name(newn);
 store2=set_wind(0,90,230,133);
 block(0,90,230,130,15);  block(0,131,227,133,1);
 ch=cpm_drive(-1);        sour_dr=ch+65;
 gprint40(30,92,"Copy to drive:");
 gprint40(40,100,"A");    gprint40(40,108,"B");
 ch=choose(30,100,100,108,8,0);
 end_wind(0,90,230,133,store2);
 dest_dr=(ch-100) ? 'B' : 'A';
 if(dest_dr==sour_dr) /* check it's not pointless */
 {  if((strncmp(oldname,newn,12))==NULL)   return 0; }

/**** this section could be replaced ****/
  newname[0]=dest_dr;  newname[1]=':';  newname[2]=0;
  strcat(newname,newn);
  fp=fopen("st1x.bat","w");
  fprintf(fp,"copy %s %s\nstart",oldname,newname);
  fclose(fp);
  kilbuf();
  sprintf(KEYBUF,"ST1X%c",13); /* prime buffer for command.com */
  blt(PUTPNT,"\365\373\360\373",4);
  screen(0);  run_com(run_name);  exit(0);
/****************************************/
}

rename(oldname)
char *oldname;
{
 FAST char *fcb2,newname[13];
 setname(oldname,newname,0);
 cpm_pfcb(fcb1,oldname);
 cpm_bdos(15,fcb1);
 if(reg_a)  return 0; /* just in case */
 fcb2=fcb1+16;
 cpm_pfcb(fcb2,newname);
 cpm_bdos(23,fcb1);
 if(reg_a) /* NB: MSX uses reg A in cpm_bdos */
 {
  block(20,180,200,190,7);
  gprint40(20,182,"ERROR:");  gprint40(60,182,newname);
  delay(20000);
  block(20,180,200,190,7);  return 0;
 }
 return 1;
}

kill(oldname)
char *oldname;
{
 FAST char newname[13];
 setname(oldname,newname,1);
 delete(oldname);  return 1;
}

delete(oldname) /* also called from main() */
char *oldname;
{
 cpm_pfcb(fcb1,oldname);
 cpm_bdos(15,fcb1);  cpm_bdos(19,fcb1);
}

setname(oldname,newname,k) /* select old and new names */
char *oldname,*newname;
{
 FAST int which_name;
 FAST char name1[13],name2[13],name3[13],*store;
 store=set_wind(88,60,191,100);
 fill_wind(88,60,191,100);
 
 strcpy(name1,oldname);
 strcpy(name2,oldname);     strcpy(name2+9,"*  ");
 strcpy(name3,"*       ");  strcat(name3,oldname+8);

 gprint40(100,68,name1);
 gprint40(100,78,name2);
 gprint40(100,88,name3);
 block(20,180,200,190,7);
 gprint40(20,182,"^ v OLD, then");  gprint40(110,182,trig_name);

 which_name=choose(90,68,68,88,10,0);
 block(20,180,200,190,7);
 if(k)  /* kill(), so only need old name */
 {
  switch(which_name)
  {
   case 68: break;
   case 78: blt(oldname,name2,13); break;
   case 88: blt(oldname,name3,13); break;
  }
  end_wind(88,60,191,100,store);  return;
 }
 switch(which_name) /* get both old and new */
 {
  case 68: get_name(100,68,166,0,name1);
           blt(newname,name1,13); break;
  case 78: blt(oldname,name2,13);
           get_name(100,78,142,0,name2);
           blt(newname,name2,13); break;
  case 88: blt(oldname,name3,13);
           get_name(154,88,166,9,name3);
           blt(newname,name3,13); break;
 }
 end_wind(88,60,191,100,store);
}

get_name(dx,dy,rx,l,name) /* write new name */
char *name;
{
 FAST char flet;
 FAST int d,lx;
 lx=dx;  put_sprite(1,dx,dy,4,1);
 block(20,180,200,190,7);
 gprint40(20,182,"< > NEW, then");  gprint40(110,182,trig_name);
 flet=name[l];
 delay(500);
 while(TRUE)
 {
  d=stick(stk_id);
  if(d==3 && dx<rx)  { dx+=6; l+=1; }
  if(d==7 && dx>lx)  { dx-=6; l-=1; }
  if(name[l]=='.')
   {
    if(d==3)  { dx+=6; l+=1; }
    else  { dx-=6; l-=1; }
   }
  put_sprite(1,dx,dy,4,1);
  if(d==3 || d==7)
  { beep(); flet=name[l]; }
  if(d==1) flet+=1;
  if(d==5) flet-=1;
  if(flet=='A'-1) flet='9';
  if(flet=='0'-1) flet=' ';
  if(flet==' '-1) flet='Z';
  if(flet==' '+1) flet='0';
  if(flet=='9'+1) flet='A';
  if(flet=='Z'+1) flet=' ';
  name[l]=flet;
  block(dx+5,dy+7,dx,dy,15);
  calslt(flet,0,0,0,GRPPRT); /* print char to screen */
  if(strig(stk_id))
  {  beep();  un_sprite(1);  return;  }
  delay(1000);
 }
}
  
get_dir(afn, sp) /* get and sort directory */
char *afn, *sp;
{
  extern int strcmp();
  FAST char bufpos,*spstart;
  FAST int count, search_code;
  char disk_buffer[128];
  spstart=sp;  count=0;
  cpm_bdos(26, disk_buffer); /* set dma */
  cpm_pfcb(fcb1, afn);       /* make fcb */
  search_code=17;	     /* search for first */
  while ((bufpos=cpm_bdos(search_code, fcb1)) != 255)
  {
   search_code=18;	     /* search for next */
   blt(sp,(disk_buffer+bufpos*32)+1,11);
   sp+=11;   *sp++=0;   count++;
  }
  *sp=0;       /* extra 0 to mark end */
  cpm_bdos(26,0x100);
  qsort(spstart,count,12,strcmp);
}

alter_date()
{
 FAST int d,m,y;
 FAST char to_day[5];
 while(TRUE)
 {
  put_sprite(0,160,2,1,0);
  d=put_num(194,2,1,31,date.day);
  m=put_num(212,2,1,12,date.month);
  y=put_num(242,2,86,99,86);
  if(!new_date(d,m,y))
   break;
 }
 old_date();
 sprintf(to_day,"%s",date.day_name);
 block(170,1,188,9,7);
 gprint40(170,2,to_day);
}

printer() /* currently MSX, but could obviously be changed */
{
 FAST int ch;
 ch=50;
 fill_wind(40,40,143,143);
 block(20,180,200,190,7);
 gprint40(20,182,"Make sure printer is on");
 gprint40(60,50,"face");    face();
 gprint40(60,60,"bold");    bold();
 gprint40(60,70,"double");  dubl();
 gprint40(60,80,"script");  scri();
 gprint40(60,90,"vertLF");  vlf();
 gprint40(60,100,"margin"); left();
 gprint40(60,110,"zero");   zero();
 gprint40(70,120,"RESET");
 gprint40(70,130,"SET");
 while(TRUE)
 {
  ch=choose(50,ch,50,130,10,0);
  if(ch==130)  break;
  switch(ch)
  {
   case 50:  face_(); left_marg=200; left_(); break;
   case 60:  bold_(); break;
   case 70:  dubl_(); left_marg=200; left_(); break;
   case 80:  scri_(); break;
   case 90:  vlf_();  break;
   case 100: left_(); break;
   case 110: zero_(); break;
   case 120: prt_data(); face(); bold(); dubl();
             scri(); vlf(); left(); zero(); break;
  }
 delay(1000);
 }
 freopen("LST:","w",stdout);
 prt_[19]=0;  printf("%s",prt_);
 freopen("CON:","w",stdout);
 block(40,40,143,143,14);
 return;
}

   /* functions to set printer drive */
/* the settings given are for an MSX printer */
/* but could obviously be changed. Initial   */
/* settings are in prt_data()                */

face_()
{
 switch(prt_[4])
 {
  case 0x4e: prt_[4]=0x50; break;
  case 0x50: prt_[4]=0x51; break;
  case 0x51: prt_[4]=0x45; break;
  default:   prt_[4]=0x4e; break;
 }
 face();
}

face()
{
 block(100,50,140,58,15);
 switch(prt_[4])
 {
  case 0x4e: gprint40(102,50,"Pica"); break;
  case 0x50: gprint40(102,50,"Prop"); break;
  case 0x51: gprint40(102,50,"Cond"); break;
  default:  gprint40(102,50,"Elite"); break;
 }
}
bold_()
{
 prt_[2]=(prt_[2]==0x21) ? 0x22 : 0x21;
 bold();
}
bold()
{
 block(100,60,140,68,15);
 switch(prt_[2])
 {
  case 0x21: gprint40(102,60,"on"); break;
  default:   gprint40(102,60,"off");
 }
}
dubl_()
{
 prt_[0]=(prt_[0]==0xe) ? 0xf : 0xe;
 dubl();
}
dubl()
{
 block(100,70,140,78,15);
 switch(prt_[0])
 {
  case 0xe: gprint40(102,70,"on"); break;
  default:  gprint40(102,70,"off");
 }
}
scri_()
{
 switch(prt_[7])
 {
  case 0x31: prt_[7]=0x32; break;
  case 0x32: prt_[7]=0x30; break;
  default:   prt_[7]=0x31; break;
 }
 scri();
}
scri()
{
 block(100,80,140,88,15);
 switch(prt_[7])
 {
  case 0x31: gprint40(102,80,"Super"); break;
  case 0x32: gprint40(102,80,"Sub");   break;
  default:   gprint40(102,80,"Normal");
 }
}
vlf_()
{
 prt_[9]=(prt_[9]==0x42) ? 0x41 : 0x42;
 vlf();
}
vlf()
{
 block(100,90,140,98,15);
 switch(prt_[9])
 {
  case 0x42: gprint40(102,90,"1/8"); break;
  default:   gprint40(102,90,"1/6");
 }
}
left_()
{
 FAST int max_r;
 switch(prt_[4])
 {
  case 0x4e: case 0x50: max_r=80; break;
  case 0x51: max_r=136; break;
  case 0x45: max_r=96; break;
 }
 if(prt_[0]==0xe)  max_r/=2;
 if(left_marg<max_r)  left_marg++;
 else  left_marg=0;
 sprintf(prt_+16,"%03d",left_marg);
 left();
}

left()
{
 block(100,100,140,108,15);
 gprint40(102,100,prt_+16);
 return;
}
zero_()
{
 prt_[11]=(prt_[11]==0x5a) ? 0x44 : 0x5a;
 zero();
}

zero()
{
 block(100,110,140,118,15);
 switch(prt_[11])
 {
  case 0x5a: gprint40(102,110,"O"); break;
  default:   gprint40(102,110,"0");
 }
}

typefile(fname) /* screen or screen & printer dump */
char *fname;
{
 FILE *fp,*prt_fp,*fopen();
 FAST int ch,prt_flag;
 FAST char *store;
 store=set_wind(157,14,247,122);
 chk_name(fname);
 block(0,180,200,190,7);
 gprint40(20,182,"SCREEN  PRINT");
 ch=choose(10,182,10,56,46,1);
 block(0,180,200,190,7);
 prt_flag=(ch==56) ? 1 : 0;
 prt_fp=fopen("LST:","w");
 block(0,180,200,190,7);
 gprint40(20,182,"ASC   HEX");
 ch=choose(10,182,10,46,36,1);
 block(0,180,200,190,7);  block(0,12,255,179,15);
 if((ch==46)&&(fp=fopen(fname,"rb")))
 {  typehex(fp,prt_fp,prt_flag);  fclose(fp);  }
 if((ch==10)&&(fp=fopen(fname,"r")))
 {  typeasc(fp,prt_fp,prt_flag);  fclose(fp);  }
 fclose(prt_fp);
 gprint40(20,182,"Finished:");  gprint40(80,182,trig_name);
 while(!strig(stk_id));
 block(0,180,200,190,7);  block(0,12,255,179,14);
 end_wind(157,14,247,122,store);
}

typeasc(fp,prt_fp,prt_flag) /* ASC text dump */
FILE *fp,*prt_fp;
{
 FAST int ch,count,end_flag,line;
 FAST char *str,type_str[41];
 count=line=end_flag=0;
 str=type_str;
 while(TRUE)
 {
  while(TRUE)
  {
   *str=getc(fp);
   if(*str==255)  {  end_flag=1;  break;  }
   if(*str=='\n') break;
   *str++;   count++;
   if(count>39) break;
  }
  if(prt_flag)
  {
   *(str+1)=0;
   fprintf(prt_fp,"%s",type_str);
  }
  *str=0;
  gprint40(8,20+(line*8),type_str);
  if(end_flag)break;
  count=0;  str=type_str;  line++;
  if(line>19)
  {
   ch=type_ch();
   if (ch==46)  return;
   if (ch==82)  prt_flag=prt_flag ? 0 : 1;
   line=0;
  }
 }
}

typehex(fp,prt_fp,prt_flag) /* HEX binary dump */
FILE *fp,*prt_fp;
{
 FAST int ch,line,count,c,i,b;
 FAST char bytes[WIDTH];
 count=line=0;
 set_x_y(8,20);
 while(TRUE)
 {
  for (i=0;i<WIDTH;i++)
  {
   if ((c=getc(fp))==EOF)  break;
   bytes[i]=c;
  }
  if(!i)  break;
  printf("%04x ",count);
  if(prt_flag)  fprintf(prt_fp,"%04x ",count);
  count+=WIDTH;
  for(b=0;b<i;b++)
  {
   printf("%02x",bytes[b]);
   if(prt_flag)  fprintf(prt_fp,"%02x ",bytes[b]);
  }
  if(i<WIDTH)
   for(b=1;b<WIDTH;b++)
   {
    printf("**");
    if(prt_flag)
     fprintf(prt_fp,"** ");
   }
  putchar(' ');
  for(b=0;b<i;b++)
  {
   c=bytes[b] & 0x7f;
   if(c<32 || c==0x7f) c='.';
   {  putchar(c);  if(prt_flag) putc(c,prt_fp);  }
  }
  putchar('\n'); putchar(' ');
  if(prt_flag)  putc('\n',prt_fp);
  if ((line++)>18)
  {
   ch=type_ch();
   if (ch==46)  return;
   if (ch==82)  prt_flag=prt_flag ? 0 : 1;
   line=0;
   set_x_y(8,20);
  }
  if (i<WIDTH) break;
 } /* end while TRUE */
}

type_ch() /* next action choice for type functions */
{
 FAST int ch;
 block(0,180,200,190,7);
 gprint40(20,182,"cont  quit  printer");
 ch=choose(10,182,10,82,36,1);
 block(0,180,200,190,7);  block(0,12,255,179,15);
 return ch;
}

int put_num(dx,dy,minn,maxn,startval) /* print number to screen */
{
 FAST char number,num_str[4];
 FAST int d;
 number=startval;
 delay(1000);
 while(!strig(stk_id))
 {
  d=stick(stk_id);
  switch(d)
     {
      case 1: number++; break;
      case 5: number--; break;
      default: break;
     }
  if(number<minn) number=maxn;
  if(number>maxn) number=minn;
  block(dx+11,dy+8,dx,dy,7);
  sprintf(num_str,"%02d",number);
  gprint40(dx,dy,num_str);
  if(strig(stk_id)) break;
  delay(1000);
 }
 beep();  delay(2000);  return number;
}

sure(fname,action) /* check decision */
char *fname,*action;
{
 FAST int ch;
 block(16,18,97,79,15);
 gprint40(24,20,fname);
 gprint40(24,64,action);
 gprint40(26,30,"Sure?");
 gprint40(30,44,"N");  gprint40(30,52,"Y");
 ch=choose(17,44,44,52,8,0);
 return (ch-44);
}

choose(x,y,min_,max_,travel,xory) /* item selection for menus */
{
 FAST int d;
 put_sprite(0,x,y,1,0);
 while(TRUE)
 {
   delay(1000);
   if(strig(stk_id)) break;
   d=stick(stk_id);
   if(xory) /* horizontal */
   {
    if(d==3 && x<max_) x+=travel;
    if(d==7 && x>min_) x-=travel;
   }
   else     /* vertical */
   {
    if(d==1 && y>min_) y-=travel;
    if(d==5 && y<max_) y+=travel;
   }
   put_sprite(0,x,y,1,0);
 }
 beep();  un_sprite(0);
 return xory ? x : y;
}

fill_wind(wl,wt,wr,wb) /* fill menu area */
{
 block(wl+3,wt,wr,wb-3,15);
 block(wl,wt+3,wl+2,wb-3,1);
 block(wl,wb-2,wr-3,wb,1);
}

delay(dur)
{  while(dur-- >0);  }

ed80_exit() /* must load command.com to reinitialize memory */
{
 FAST char *p,*addr,*fk_str;
 addr=cast(__addr_ptr) FNKSTR;
 p=addr;
 while(p<addr+160)
  *p++=0;
 fk_str="\33\36\33\37\13\26\13\3\13\31\13\102\13\113\17\20\17\6\21\24";
  /* this is an example setting - see ED80.HLP.  */
  /* fk_str should be custom designed by user    */
  /* to conform to command codes for ED80        */
  /* It may well be easier to use the set_fkey() */
  /* function in BASIC.LIB */
 while(*fk_str)
  {
     *addr++=*fk_str++; /* in this case Fkeys all use 2 byte codes */
     *addr++=*fk_str++;
     addr+=14;
  }
 width(40);  colour(15,12,4);
 sprintf(KEYBUF,"ED80%c",13); /* prime buffer for command.com */
 blt(PUTPNT,"\365\373\360\373",4);
}

chk_name(name) /* make file name legal */
char *name;
{
 FAST int ch;
 for(ch=1;ch<8;ch++)
 {
  if(isspace(name[ch]))
  {  blt(name+ch,name+8,5);  break;  }
 }
}

info() /* drive and disk free */
{
 FAST char info_str[7];
 block(200,180,255,190,7);
 sprintf(info_str,"%c:%dk",(cpm_drive(-1)+65),dskf(0));
 gprint40(218,182,info_str);
}

prt_data() /* initial printer settings - currently MSX */
           /* if more are required increase prt_[]     */
           /* - see also printer() and face() above.   */
{
   prt_[0]=0xf;  /* double */
   prt_[1]=0x1b;  prt_[2]=0x22;   /* bold */
   prt_[3]=0x1b;  prt_[4]=0x4e;   /* face */
   prt_[5]=0x1b;  prt_[6]=0x73;  prt_[7]=0x30;   /* script */
   prt_[8]=0x1b;  prt_[9]=0x41;   /* LF pitch */
   prt_[10]=0x1b; prt_[11]=0x5a; prt_[12]=2; prt_[13]=1;/* zero */
   prt_[14]=0x1b; prt_[15]=0x4c; prt_[16]=0x30; prt_[17]=0x30; prt_[18]=0x30;/* left margin */
   prt_[19]=0;
}
#include ?basic.lib?
#include ?cpm.lib?
#include ?stdio.lib?
/**************************************/
/*****       End of START.C       *****/
/**************************************/

/**************************************/
/*****  