{$T,Y

 Compile this program using
   HP TURTMSX
}
{$L-,C-}
PROGRAM turtle;
    
VAR
  Xcor,Ycor,heading : REAL;
  penstatus : BOOLEAN;


{ *   Turtle Graphics for MSX   * }
{ * Written by Bottin Gianpaolo * }

{ * See example programs GRAPH1 * }
{ * & GRAPH2 for details of use * }

{ * Global variables for turtle * }

   heading,Xcor,Ycor,PI:REAL;
   penstatus           :BOOLEAN;

{ * PROCEDURE TO CALL HGR * }

PROCEDURE INIT;
BEGIN
     POKE(#FB00,8);
     POKE(#FB01,#DB);
     POKE(#FB02,#A8);
     POKE(#FB03,#F5);
     POKE(#FB04,#E6);
     POKE(#FB05,#F0);
     POKE(#FB06,#C3);
     POKE(#FB07,#F38C);
END;



PROCEDURE CALL(IND:INTEGER);
BEGIN
     INLINE(#DD,#E5,    { PUSH IX }
	    #DD,#6E,2,  { LD L,(IX+2) }
     	#DD,#66,3,  { LD H,(IX+3) }
     	#E5,        { PUSH HL }
     	#DD,#E1,    { POP IX  }
     	#3A,#AF,#FC,{ LD A,(#FCAF }
     	#CD,0,#FB,  { CALL #FB00  }
     	#DD,#E1);    { POP IX }
END;


PROCEDURE line(X1,Y1,X2,Y2:INTEGER);
BEGIN
     POKE(#FCB7,X2);
     POKE(#FCB9,Y2);
     POKE(#FCB3,X1);
     POKE(#FCB5,Y1);
     INLINE(
 	#DD,#E5,    { PUSH IX }
     	#DD,#5E,2,  { LD E,(IX+2) }
     	#DD,#56,3,  { LD D,(IX+3) }
     	#DD,#4E,4,  { LD C,(IX+4) }
     	#DD,#46,5,  { LD B,(IX+5) }
     	#DD,#21,#FC,#58, { LD IX,#58FC }
     	#CD,0,#FB,  { CALL #FB00  }
     	#DD,#E1);    { POP IX }
END;


PROCEDURE CLS;
BEGIN
     CALL(#C3);
END;


PROCEDURE mode(I:INTEGER);
BEGIN
     POKE(#FCAF,CHR(I));
     CALL(#5F);
END;


PROCEDURE ink(I:INTEGER);
BEGIN
     POKE(#F3F2,CHR(I));
     POKE(#F3E9,CHR(I));
     CALL(#62);
END;


PROCEDURE paper(I:INTEGER);
BEGIN
     POKE(#F3EA,CHR(I));
     CALL(#62);
END;


PROCEDURE border(I:INTEGER);
BEGIN
     POKE(#F3EB,CHR(I));
     CALL(#62);
END;


PROCEDURE pendown(I:INTEGER);
BEGIN
     penstatus:=TRUE;
     ink(I);
END;


PROCEDURE PENUP;
BEGIN
     penstatus:=FALSE;
END;


PROCEDURE sethd(AN:REAL);
BEGIN
     heading:=AN;
END;


PROCEDURE setXY(X,Y:REAL);
BEGIN
     Xcor:=X;
     Ycor:=Y;
END;


PROCEDURE fwd(len:REAL);
CONST PIby180 = 1.745329E-2;
VAR newX,newY:REAL;
BEGIN
 newX:=Xcor+len*COS(heading*PIby180);
 newY:=Ycor+len*SIN(heading*PIby180);
 IF penstatus THEN line(ROUND(Xcor*3/8),ROUND(Ycor*192/400),
                        ROUND(newX*3/8),ROUND(newY*192/400));
 Xcor:=newX;
 Ycor:=newY
END;

PROCEDURE back(LEN:INTEGER);
BEGIN
     heading:=heading+180;
     fwd(LEN);
     heading:=heading-180;
END;


PROCEDURE right(AN:REAL);
BEGIN
     heading:=heading-AN;
END;


PROCEDURE left(AN:REAL);
BEGIN
     heading:=heading+AN;
END;

PROCEDURE arcr(r:REAL;deg:INTEGER);
VAR i:INTEGER;
BEGIN
 FOR i:=1  TO deg DO
  BEGIN
   fwd(r); right(1)
  END;
END;


PROCEDURE polyspi(side,angle,inc:REAL);
BEGIN
 fwd(side);
 right(angle);
 polyspi(side+inc,angle,inc);
END;

PROCEDURE arcl(r:REAL;deg:INTEGER);
VAR i:INTEGER;
BEGIN
 FOR i:=1 TO deg DO
   BEGIN
    fwd(r); left(1)
   END
END;

PROCEDURE hilbert(len,level,parity:INTEGER);
BEGIN
IF level <> 0 THEN
   BEGIN
      left(parity * 90);
      hilbert(len, level-1, -parity);
      fwd(len);
      right(parity * 90);
      hilbert(len, level-1, parity);
      fwd(len);
      hilbert(len, level-1, parity);
      right(parity * 90);
      fwd(len);
      hilbert(len, level-1, -parity);
      left(parity * 90)
   END
END;


PROCEDURE poly(side,angle:REAL);
BEGIN
 fwd(side); right(angle);
 IF side<180*(2+TRUNC(angle/90))/3 THEN poly(side+1,angle)
END;

PROCEDURE P(X,Y,col:INTEGER;side,angle:REAL);
BEGIN
 pendown(col);
 sethd(0);
 setXY(X,Y);
 poly(side,angle);
END;

PROCEDURE circles;
VAR i:INTEGER;
BEGIN
 FOR i:=1 TO 9 DO
   BEGIN
    arcr(1,360);right(40)
   END;
END;

PROCEDURE petal(s:REAL);
BEGIN
 arcr(s,60);
 right(120);
 arcr(s,60);
 right(120)
END;

PROCEDURE flower(s:REAL);
VAR i:INTEGER;
BEGIN
 FOR i:=1 TO 6 DO 
  BEGIN
   petal(s);
   right(60)
  END
END;

PROCEDURE turtle;
BEGIN
     INIT; 
     heading:=0;
     Xcor:=300;
     Ycor:=200;
     penstatus:=TRUE;
     mode(2);
     border(1)
END;


BEGIN
 turtle;

 flower(2);
 setXY(50,200);
 hilbert(10,4,1);
 READLN; MODE(0); INK(15); PAPER(4);
END.
(1)
